//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "OpenGl.h"
#include <assert.h>

//---------------------------------------------------------------------------
#pragma package(smart_init)
TSceneFile::TSceneFile(const char * fileName, bool write, int ver)
{
    ok = false;
    file = fopen(fileName, write ? "w" : "r");
    writing = write;
    if (file)
        ok = true;
    if (writing)
        {
        ok = ok && fwrite(&ver, sizeof(int), 1, file) == 1;
        version = ver;
        }
    else
        ok = ok && fread(&version, sizeof(int), 1, file) == 1;
}

bool TSceneFile::Write(void * value, int size)
{
    if (!writing)
        return false;
    ok = ok && fwrite(&size, sizeof(int), 1, file) == 1;
    ok = ok && fwrite(value, 1, size, file) == (unsigned)size;
    return ok;
}

bool TSceneFile::Read(void * value, int &len, int maxsize)
{
    ok = ok && fread(&len, sizeof(int), 1, file) == 1;
    if (!ok)
        return false;
    if (maxsize >= len)
        {
        ok = ok && fread(value, 1, len, file) == (unsigned)len;
        return ok;
        }
    else
        return false;
}

TSceneFile::~TSceneFile()
{
    if (file)
        fclose(file);
}

bool TSceneFile::writeString(String value)
{
    assert(writing);
    int len = value.Length();
    char mmm[1000];
    strncpy(mmm, value.c_str(), 999);
    mmm[999]=0;
    Write(mmm, len);
    return ok;
}

bool TSceneFile::readString(int ver, String & value, String defval)
{
    assert(!writing);

    if (ver > version)
        {
        value = defval;
        return true;
        }

    int len=0;
    char mmm[1000];

    if (Read(mmm, len, 999))
        {
        mmm[len]=0;
        value = mmm;
        return true;
        }
    return false;
}

bool TSceneFile::writeInt(int value)
{
    assert(writing);
    ok = ok && fwrite(&value, sizeof(int), 1, file) == 1;
    return ok;
}

bool TSceneFile::readInt(int ver, int & value, int defval)
{
    assert(!writing);
    if (ver > version)
        {
        value = defval;
        return true;
        }
    ok = ok && fread(&value, sizeof(int), 1, file) == 1;
    return ok;
}

bool TSceneFile::writeFloat(float value)
{
    assert(writing);
    ok = ok && fwrite(&value, sizeof(float), 1, file) == 1;
    return ok;
}

bool TSceneFile::readFloat(int ver, float & value, float defval)
{
    assert(!writing);
    if (ver > version)
        {
        value = defval;
        return true;
        }
    ok = ok && fread(&value, sizeof(float), 1, file) == 1;
    return ok;
}

